=== modified file 'Makefile'
--- Makefile	2011-10-15 16:48:03 +0000
+++ Makefile	2011-10-11 19:36:00 +0000
@@ -23,7 +23,7 @@
 OPTIMIZE=-Os
 LANGUAGE=-std=gnu99
 htmldir=man
-version=1.4.1
+version=1.4.0
 SED=sed
 
 ## Use these settings for a traditional /usr/local install

=== modified file 'NEWS'
--- NEWS	2011-10-15 16:48:03 +0000
+++ NEWS	2011-10-09 17:36:01 +0000
@@ -1,12 +1,6 @@
 This NEWS file records noteworthy changes, very tersely.
 See the manual for detailed information.
 
-Version 1.4.1 (2011-10-15)
-* Server
-** Make D-Bus properties settable again, and handle checkers
-   for disabled clients correctly.
-* Miscellaneous fixes to "pedantic" Lintian warnings
-
 Version 1.4.0 (2011-10-09)
 * README file migrated to manual page intro(8mandos).
 * Client:

=== modified file 'TODO'
--- TODO	2011-11-13 13:55:45 +0000
+++ TODO	2011-10-09 15:21:16 +0000
@@ -7,7 +7,6 @@
 * mandos-applet
 
 * mandos-client
-** TODO [#A] Document network hook functionality
 ** TODO [#B] Use capabilities instead of seteuid().
 ** TODO [#B] Use struct sockaddr_storage instead of a union
 ** TODO [#B] Use getaddrinfo(hints=AI_NUMERICHOST) instead of inet_pton()
@@ -67,7 +66,6 @@
 ** TODO [#C] python-parsedatetime
 ** TODO [#C] systemd/launchd
    http://0pointer.de/blog/projects/systemd.html
-   http://wiki.debian.org/systemd
 ** TODO Separate logging logic to own object
 ** TODO make clients to a dict!
 ** TODO [#A] Limit approval_delay to max gnutls/tls timeout value
@@ -83,7 +81,6 @@
 *** Handle "no D-Bus server" and/or "no Mandos server found" better
 *** [#B] --dump option
 ** TODO Support RFC 3339 time duration syntax
-** TODO Send milliseconds if bare integer is passed as time duration
 
 * TODO mandos-dispatch
   Listens for specified D-Bus signals and spawns shell commands with

=== modified file 'common.ent'
--- common.ent	2011-10-15 16:48:03 +0000
+++ common.ent	2011-10-09 17:36:01 +0000
@@ -1,3 +1,3 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!-- Edited by Makefile -->
-<!ENTITY version "1.4.1">
+<!ENTITY version "1.4.0">

=== modified file 'debian/changelog'
--- debian/changelog	2011-10-15 16:48:03 +0000
+++ debian/changelog	2011-10-09 17:36:01 +0000
@@ -1,16 +1,3 @@
-mandos (1.4.1-1) unstable; urgency=low
-
-  * New upstream release.
-  * debian/control (Build-Depends): Added "man".
-  * debian/control (Conflicts): Changed to "Breaks:".
-  * debian/copyright: Updated format.
-  * debian/mandos-client.postinst: Use "set -e" instead of "#!/bin/sh -e".
-  * debian/mandos-client.postrm: - '' -
-  * debian/mandos.postinst: - '' -
-  * debian/mandos.prerm: Consistent magic.
-
- -- Björn Påhlsson <belorn@fukt.bsnet.se>  Sat, 15 Oct 2011 18:18:52 +0200
-
 mandos (1.4.0-1) unstable; urgency=low
 
   * New upstream release.

=== modified file 'mandos'
--- mandos	2011-10-15 16:48:03 +0000
+++ mandos	2011-10-10 20:29:58 +0000
@@ -83,7 +83,7 @@
         SO_BINDTODEVICE = None
 
 
-version = "1.4.1"
+version = "1.4.0"
 
 #logger = logging.getLogger('mandos')
 logger = logging.Logger('mandos')
@@ -464,13 +464,11 @@
         if timeout is None:
             timeout = self.timeout
         self.last_checked_ok = datetime.datetime.utcnow()
-        if self.disable_initiator_tag is not None:
-            gobject.source_remove(self.disable_initiator_tag)
-        if getattr(self, "enabled", False):
-            self.disable_initiator_tag = (gobject.timeout_add
-                                          (_timedelta_to_milliseconds
-                                           (timeout), self.disable))
-            self.expires = datetime.datetime.utcnow() + timeout
+        gobject.source_remove(self.disable_initiator_tag)
+        self.disable_initiator_tag = (gobject.timeout_add
+                                      (_timedelta_to_milliseconds
+                                       (timeout), self.disable))
+        self.expires = datetime.datetime.utcnow() + timeout
     
     def need_approval(self):
         self.last_approval_request = datetime.datetime.utcnow()
@@ -893,8 +891,8 @@
         """ Modify a variable so that it's a property which announces
         its changes to DBus.
 
-        transform_fun: Function that takes a value and a variant_level
-                       and transforms it to a D-Bus type.
+        transform_fun: Function that takes a value and transforms it
+                       to a D-Bus type.
         dbus_name: D-Bus name of the variable
         type_func: Function that transform the value before sending it
                    to the D-Bus.  Default: no transform
@@ -907,8 +905,7 @@
                     type_func(getattr(self, attrname, None))
                     != type_func(value)):
                     dbus_value = transform_func(type_func(value),
-                                                variant_level
-                                                =variant_level)
+                                                variant_level)
                     self.PropertyChanged(dbus.String(dbus_name),
                                          dbus_value)
             setattr(self, attrname, value)
@@ -1190,11 +1187,12 @@
         gobject.source_remove(self.disable_initiator_tag)
         self.disable_initiator_tag = None
         self.expires = None
-        time_to_die = _timedelta_to_milliseconds((self
-                                                  .last_checked_ok
-                                                  + self.timeout)
-                                                 - datetime.datetime
-                                                 .utcnow())
+        time_to_die = (self.
+                       _timedelta_to_milliseconds((self
+                                                   .last_checked_ok
+                                                   + self.timeout)
+                                                  - datetime.datetime
+                                                  .utcnow()))
         if time_to_die <= 0:
             # The timeout has passed
             self.disable()

=== modified file 'mandos-ctl'
--- mandos-ctl	2011-10-15 16:48:03 +0000
+++ mandos-ctl	2011-10-09 17:36:01 +0000
@@ -60,7 +60,7 @@
 server_path = "/"
 server_interface = domain + ".Mandos"
 client_interface = domain + ".Mandos.Client"
-version = "1.4.1"
+version = "1.4.0"
 
 def timedelta_to_milliseconds(td):
     """Convert a datetime.timedelta object to milliseconds"""
@@ -301,41 +301,41 @@
                                          dbus_interface=
                                          dbus.PROPERTIES_IFACE)
                          else 1)
-            if options.checker is not None:
+            if options.checker:
                 client.Set(client_interface, "Checker",
                            options.checker,
                            dbus_interface=dbus.PROPERTIES_IFACE)
-            if options.host is not None:
+            if options.host:
                 client.Set(client_interface, "Host", options.host,
                            dbus_interface=dbus.PROPERTIES_IFACE)
-            if options.interval is not None:
+            if options.interval:
                 client.Set(client_interface, "Interval",
                            timedelta_to_milliseconds
                            (string_to_delta(options.interval)),
                            dbus_interface=dbus.PROPERTIES_IFACE)
-            if options.approval_delay is not None:
+            if options.approval_delay:
                 client.Set(client_interface, "ApprovalDelay",
                            timedelta_to_milliseconds
                            (string_to_delta(options.
                                             approval_delay)),
                            dbus_interface=dbus.PROPERTIES_IFACE)
-            if options.approval_duration is not None:
+            if options.approval_duration:
                 client.Set(client_interface, "ApprovalDuration",
                            timedelta_to_milliseconds
                            (string_to_delta(options.
                                             approval_duration)),
                            dbus_interface=dbus.PROPERTIES_IFACE)
-            if options.timeout is not None:
+            if options.timeout:
                 client.Set(client_interface, "Timeout",
                            timedelta_to_milliseconds
                            (string_to_delta(options.timeout)),
                            dbus_interface=dbus.PROPERTIES_IFACE)
-            if options.extended_timeout is not None:
+            if options.extended_timeout:
                 client.Set(client_interface, "ExtendedTimeout",
                            timedelta_to_milliseconds
                            (string_to_delta(options.extended_timeout)),
                            dbus_interface=dbus.PROPERTIES_IFACE)
-            if options.secret is not None:
+            if options.secret:
                 client.Set(client_interface, "Secret",
                            dbus.ByteArray(open(options.secret,
                                                "rb").read()),

=== modified file 'mandos-keygen'
--- mandos-keygen	2011-10-15 16:48:03 +0000
+++ mandos-keygen	2011-10-09 17:36:01 +0000
@@ -21,7 +21,7 @@
 # Contact the authors at <mandos@recompile.se>.
 # 
 
-VERSION="1.4.1"
+VERSION="1.4.0"
 
 KEYDIR="/etc/keys/mandos"
 KEYTYPE=DSA

=== modified file 'mandos-monitor'
--- mandos-monitor	2011-10-15 16:48:03 +0000
+++ mandos-monitor	2011-10-09 17:36:01 +0000
@@ -52,7 +52,7 @@
 domain = 'se.recompile'
 server_interface = domain + '.Mandos'
 client_interface = domain + '.Mandos.Client'
-version = "1.4.1"
+version = "1.4.0"
 
 # Always run in monochrome mode
 urwid.curses_display.curses.has_colors = lambda : False

=== modified file 'mandos.lsm'
--- mandos.lsm	2011-10-15 16:48:03 +0000
+++ mandos.lsm	2011-10-09 17:36:01 +0000
@@ -1,7 +1,7 @@
 Begin4
 Title:		Mandos
-Version:	1.4.1
-Entered-date:	2011-10-15
+Version:	1.4.0
+Entered-date:	2011-10-09
 Description:	The Mandos system allows computers to have encrypted
 root file systems and at the same time be capable of remote and/or
 unattended reboots.
@@ -12,9 +12,9 @@
 Maintained-by:	teddy@recompile.se (Teddy Hogeborn),
 		belorn@recompile.se (Björn Påhlsson)
 Primary-site: http://www.recompile.se/mandos
-	      138K mandos_1.4.1.orig.tar.gz
+	      137K mandos_1.4.0.orig.tar.gz
 Alternate-site: ftp://ftp.recompile.se/pub/mandos
-		138K mandos_1.4.1.orig.tar.gz
+		137K mandos_1.4.0.orig.tar.gz
 Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.6, and
 various other libraries.  While made for Debian GNU/Linux, it is
 probably portable to other distributions, but not other Unixes.

=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2011-11-13 13:55:45 +0000
+++ plugins.d/mandos-client.c	2011-10-05 16:00:56 +0000
@@ -53,7 +53,7 @@
 				   sockaddr_in6, PF_INET6,
 				   SOCK_STREAM, uid_t, gid_t, open(),
 				   opendir(), DIR */
-#include <sys/stat.h>		/* open(), S_ISREG */
+#include <sys/stat.h>		/* open() */
 #include <sys/socket.h>		/* socket(), struct sockaddr_in6,
 				   inet_pton(), connect() */
 #include <fcntl.h>		/* open() */
@@ -85,8 +85,6 @@
 				   raise() */
 #include <sysexits.h>		/* EX_OSERR, EX_USAGE, EX_UNAVAILABLE,
 				   EX_NOHOST, EX_IOERR, EX_PROTOCOL */
-#include <sys/wait.h>		/* waitpid(), WIFEXITED(),
-				   WEXITSTATUS(), WTERMSIG() */
 
 #ifdef __linux__
 #include <sys/klog.h> 		/* klogctl() */
@@ -110,8 +108,8 @@
 				   init_gnutls_session(),
 				   GNUTLS_* */
 #include <gnutls/openpgp.h>
-			 /* gnutls_certificate_set_openpgp_key_file(),
-			    GNUTLS_OPENPGP_FMT_BASE64 */
+			  /* gnutls_certificate_set_openpgp_key_file(),
+				   GNUTLS_OPENPGP_FMT_BASE64 */
 
 /* GPGME */
 #include <gpgme.h> 		/* All GPGME types, constants and
@@ -125,7 +123,6 @@
 #define PATHDIR "/conf/conf.d/mandos"
 #define SECKEY "seckey.txt"
 #define PUBKEY "pubkey.txt"
-#define HOOKDIR "/lib/mandos/network-hooks.d"
 
 bool debug = false;
 static const char mandos_protocol_version[] = "1";
@@ -133,7 +130,6 @@
 const char *argp_program_bug_address = "<mandos@recompile.se>";
 static const char sys_class_net[] = "/sys/class/net";
 char *connect_to = NULL;
-const char *hookdir = HOOKDIR;
 
 /* Doubly linked list that need to be circularly linked when used */
 typedef struct server{
@@ -180,7 +176,7 @@
  * "buffer_length" is how much is already used.
  */
 size_t incbuffer(char **buffer, size_t buffer_length,
-		 size_t buffer_capacity){
+		  size_t buffer_capacity){
   if(buffer_length + BUFFER_SIZE > buffer_capacity){
     *buffer = realloc(*buffer, buffer_capacity + BUFFER_SIZE);
     if(buffer == NULL){
@@ -192,8 +188,9 @@
 }
 
 /* Add server to set of servers to retry periodically */
-int add_server(const char *ip, uint16_t port, AvahiIfIndex if_index,
-	       int af){
+int add_server(const char *ip, uint16_t port,
+		 AvahiIfIndex if_index,
+		 int af){
   int ret;
   server *new_server = malloc(sizeof(server));
   if(new_server == NULL){
@@ -201,9 +198,9 @@
     return -1;
   }
   *new_server = (server){ .ip = strdup(ip),
-			  .port = port,
-			  .if_index = if_index,
-			  .af = af };
+			 .port = port,
+			 .if_index = if_index,
+			 .af = af };
   if(new_server->ip == NULL){
     perror_plus("strdup");
     return -1;
@@ -231,8 +228,8 @@
 /* 
  * Initialize GPGME.
  */
-static bool init_gpgme(const char *seckey, const char *pubkey,
-		       const char *tempdir){
+static bool init_gpgme(const char *seckey,
+		       const char *pubkey, const char *tempdir){
   gpgme_error_t rc;
   gpgme_engine_info_t engine_info;
   
@@ -253,16 +250,14 @@
     
     rc = gpgme_data_new_from_fd(&pgp_data, fd);
     if(rc != GPG_ERR_NO_ERROR){
-      fprintf(stderr, "Mandos plugin mandos-client: "
-	      "bad gpgme_data_new_from_fd: %s: %s\n",
+      fprintf(stderr, "bad gpgme_data_new_from_fd: %s: %s\n",
 	      gpgme_strsource(rc), gpgme_strerror(rc));
       return false;
     }
     
     rc = gpgme_op_import(mc.ctx, pgp_data);
     if(rc != GPG_ERR_NO_ERROR){
-      fprintf(stderr, "Mandos plugin mandos-client: "
-	      "bad gpgme_op_import: %s: %s\n",
+      fprintf(stderr, "bad gpgme_op_import: %s: %s\n",
 	      gpgme_strsource(rc), gpgme_strerror(rc));
       return false;
     }
@@ -276,16 +271,14 @@
   }
   
   if(debug){
-    fprintf(stderr, "Mandos plugin mandos-client: "
-	    "Initializing GPGME\n");
+    fprintf(stderr, "Initializing GPGME\n");
   }
   
   /* Init GPGME */
   gpgme_check_version(NULL);
   rc = gpgme_engine_check_version(GPGME_PROTOCOL_OpenPGP);
   if(rc != GPG_ERR_NO_ERROR){
-    fprintf(stderr, "Mandos plugin mandos-client: "
-	    "bad gpgme_engine_check_version: %s: %s\n",
+    fprintf(stderr, "bad gpgme_engine_check_version: %s: %s\n",
 	    gpgme_strsource(rc), gpgme_strerror(rc));
     return false;
   }
@@ -293,8 +286,7 @@
   /* Set GPGME home directory for the OpenPGP engine only */
   rc = gpgme_get_engine_info(&engine_info);
   if(rc != GPG_ERR_NO_ERROR){
-    fprintf(stderr, "Mandos plugin mandos-client: "
-	    "bad gpgme_get_engine_info: %s: %s\n",
+    fprintf(stderr, "bad gpgme_get_engine_info: %s: %s\n",
 	    gpgme_strsource(rc), gpgme_strerror(rc));
     return false;
   }
@@ -307,17 +299,15 @@
     engine_info = engine_info->next;
   }
   if(engine_info == NULL){
-    fprintf(stderr, "Mandos plugin mandos-client: "
-	    "Could not set GPGME home dir to %s\n", tempdir);
+    fprintf(stderr, "Could not set GPGME home dir to %s\n", tempdir);
     return false;
   }
   
   /* Create new GPGME "context" */
   rc = gpgme_new(&(mc.ctx));
   if(rc != GPG_ERR_NO_ERROR){
-    fprintf(stderr, "Mandos plugin mandos-client: "
-	    "bad gpgme_new: %s: %s\n", gpgme_strsource(rc),
-	    gpgme_strerror(rc));
+    fprintf(stderr, "bad gpgme_new: %s: %s\n",
+	    gpgme_strsource(rc), gpgme_strerror(rc));
     return false;
   }
   
@@ -342,16 +332,14 @@
   ssize_t plaintext_length = 0;
   
   if(debug){
-    fprintf(stderr, "Mandos plugin mandos-client: "
-	    "Trying to decrypt OpenPGP data\n");
+    fprintf(stderr, "Trying to decrypt OpenPGP data\n");
   }
   
   /* Create new GPGME data buffer from memory cryptotext */
   rc = gpgme_data_new_from_mem(&dh_crypto, cryptotext, crypto_size,
 			       0);
   if(rc != GPG_ERR_NO_ERROR){
-    fprintf(stderr, "Mandos plugin mandos-client: "
-	    "bad gpgme_data_new_from_mem: %s: %s\n",
+    fprintf(stderr, "bad gpgme_data_new_from_mem: %s: %s\n",
 	    gpgme_strsource(rc), gpgme_strerror(rc));
     return -1;
   }
@@ -359,8 +347,7 @@
   /* Create new empty GPGME data buffer for the plaintext */
   rc = gpgme_data_new(&dh_plain);
   if(rc != GPG_ERR_NO_ERROR){
-    fprintf(stderr, "Mandos plugin mandos-client: "
-	    "bad gpgme_data_new: %s: %s\n",
+    fprintf(stderr, "bad gpgme_data_new: %s: %s\n",
 	    gpgme_strsource(rc), gpgme_strerror(rc));
     gpgme_data_release(dh_crypto);
     return -1;
@@ -370,37 +357,29 @@
      data buffer */
   rc = gpgme_op_decrypt(mc.ctx, dh_crypto, dh_plain);
   if(rc != GPG_ERR_NO_ERROR){
-    fprintf(stderr, "Mandos plugin mandos-client: "
-	    "bad gpgme_op_decrypt: %s: %s\n",
+    fprintf(stderr, "bad gpgme_op_decrypt: %s: %s\n",
 	    gpgme_strsource(rc), gpgme_strerror(rc));
     plaintext_length = -1;
     if(debug){
       gpgme_decrypt_result_t result;
       result = gpgme_op_decrypt_result(mc.ctx);
       if(result == NULL){
-	fprintf(stderr, "Mandos plugin mandos-client: "
-		"gpgme_op_decrypt_result failed\n");
+	fprintf(stderr, "gpgme_op_decrypt_result failed\n");
       } else {
-	fprintf(stderr, "Mandos plugin mandos-client: "
-		"Unsupported algorithm: %s\n",
+	fprintf(stderr, "Unsupported algorithm: %s\n",
 		result->unsupported_algorithm);
-	fprintf(stderr, "Mandos plugin mandos-client: "
-		"Wrong key usage: %u\n",
+	fprintf(stderr, "Wrong key usage: %u\n",
 		result->wrong_key_usage);
 	if(result->file_name != NULL){
-	  fprintf(stderr, "Mandos plugin mandos-client: "
-		  "File name: %s\n", result->file_name);
+	  fprintf(stderr, "File name: %s\n", result->file_name);
 	}
 	gpgme_recipient_t recipient;
 	recipient = result->recipients;
 	while(recipient != NULL){
-	  fprintf(stderr, "Mandos plugin mandos-client: "
-		  "Public key algorithm: %s\n",
+	  fprintf(stderr, "Public key algorithm: %s\n",
 		  gpgme_pubkey_algo_name(recipient->pubkey_algo));
-	  fprintf(stderr, "Mandos plugin mandos-client: "
-		  "Key ID: %s\n", recipient->keyid);
-	  fprintf(stderr, "Mandos plugin mandos-client: "
-		  "Secret key available: %s\n",
+	  fprintf(stderr, "Key ID: %s\n", recipient->keyid);
+	  fprintf(stderr, "Secret key available: %s\n",
 		  recipient->status == GPG_ERR_NO_SECKEY
 		  ? "No" : "Yes");
 	  recipient = recipient->next;
@@ -411,8 +390,7 @@
   }
   
   if(debug){
-    fprintf(stderr, "Mandos plugin mandos-client: "
-	    "Decryption of OpenPGP data succeeded\n");
+    fprintf(stderr, "Decryption of OpenPGP data succeeded\n");
   }
   
   /* Seek back to the beginning of the GPGME plaintext data buffer */
@@ -425,12 +403,12 @@
   *plaintext = NULL;
   while(true){
     plaintext_capacity = incbuffer(plaintext,
-				   (size_t)plaintext_length,
-				   plaintext_capacity);
+				      (size_t)plaintext_length,
+				      plaintext_capacity);
     if(plaintext_capacity == 0){
-      perror_plus("incbuffer");
-      plaintext_length = -1;
-      goto decrypt_end;
+	perror_plus("incbuffer");
+	plaintext_length = -1;
+	goto decrypt_end;
     }
     
     ret = gpgme_data_read(dh_plain, *plaintext + plaintext_length,
@@ -449,8 +427,7 @@
   }
   
   if(debug){
-    fprintf(stderr, "Mandos plugin mandos-client: "
-	    "Decrypted password is: ");
+    fprintf(stderr, "Decrypted password is: ");
     for(ssize_t i = 0; i < plaintext_length; i++){
       fprintf(stderr, "%02hhX ", (*plaintext)[i]);
     }
@@ -478,7 +455,7 @@
 /* GnuTLS log function callback */
 static void debuggnutls(__attribute__((unused)) int level,
 			const char* string){
-  fprintf(stderr, "Mandos plugin mandos-client: GnuTLS: %s", string);
+  fprintf(stderr, "GnuTLS: %s", string);
 }
 
 static int init_gnutls_global(const char *pubkeyfilename,
@@ -486,14 +463,13 @@
   int ret;
   
   if(debug){
-    fprintf(stderr, "Mandos plugin mandos-client: "
-	    "Initializing GnuTLS\n");
+    fprintf(stderr, "Initializing GnuTLS\n");
   }
   
   ret = gnutls_global_init();
   if(ret != GNUTLS_E_SUCCESS){
-    fprintf(stderr, "Mandos plugin mandos-client: "
-	    "GnuTLS global_init: %s\n", safer_gnutls_strerror(ret));
+    fprintf(stderr, "GnuTLS global_init: %s\n",
+	    safer_gnutls_strerror(ret));
     return -1;
   }
   
@@ -508,15 +484,14 @@
   /* OpenPGP credentials */
   ret = gnutls_certificate_allocate_credentials(&mc.cred);
   if(ret != GNUTLS_E_SUCCESS){
-    fprintf(stderr, "Mandos plugin mandos-client: "
-	    "GnuTLS memory error: %s\n", safer_gnutls_strerror(ret));
+    fprintf(stderr, "GnuTLS memory error: %s\n",
+	    safer_gnutls_strerror(ret));
     gnutls_global_deinit();
     return -1;
   }
   
   if(debug){
-    fprintf(stderr, "Mandos plugin mandos-client: "
-	    "Attempting to use OpenPGP public key %s and"
+    fprintf(stderr, "Attempting to use OpenPGP public key %s and"
 	    " secret key %s as GnuTLS credentials\n", pubkeyfilename,
 	    seckeyfilename);
   }
@@ -526,26 +501,23 @@
      GNUTLS_OPENPGP_FMT_BASE64);
   if(ret != GNUTLS_E_SUCCESS){
     fprintf(stderr,
-	    "Mandos plugin mandos-client: "
 	    "Error[%d] while reading the OpenPGP key pair ('%s',"
 	    " '%s')\n", ret, pubkeyfilename, seckeyfilename);
-    fprintf(stderr, "Mandos plugin mandos-client: "
-	    "The GnuTLS error is: %s\n", safer_gnutls_strerror(ret));
+    fprintf(stderr, "The GnuTLS error is: %s\n",
+	    safer_gnutls_strerror(ret));
     goto globalfail;
   }
   
   /* GnuTLS server initialization */
   ret = gnutls_dh_params_init(&mc.dh_params);
   if(ret != GNUTLS_E_SUCCESS){
-    fprintf(stderr, "Mandos plugin mandos-client: "
-	    "Error in GnuTLS DH parameter initialization:"
+    fprintf(stderr, "Error in GnuTLS DH parameter initialization:"
 	    " %s\n", safer_gnutls_strerror(ret));
     goto globalfail;
   }
   ret = gnutls_dh_params_generate2(mc.dh_params, mc.dh_bits);
   if(ret != GNUTLS_E_SUCCESS){
-    fprintf(stderr, "Mandos plugin mandos-client: "
-	    "Error in GnuTLS prime generation: %s\n",
+    fprintf(stderr, "Error in GnuTLS prime generation: %s\n",
 	    safer_gnutls_strerror(ret));
     goto globalfail;
   }
@@ -572,8 +544,7 @@
     }
   } while(ret == GNUTLS_E_INTERRUPTED or ret == GNUTLS_E_AGAIN);
   if(ret != GNUTLS_E_SUCCESS){
-    fprintf(stderr, "Mandos plugin mandos-client: "
-	    "Error in GnuTLS session initialization: %s\n",
+    fprintf(stderr, "Error in GnuTLS session initialization: %s\n",
 	    safer_gnutls_strerror(ret));
   }
   
@@ -587,10 +558,9 @@
       }
     } while(ret == GNUTLS_E_INTERRUPTED or ret == GNUTLS_E_AGAIN);
     if(ret != GNUTLS_E_SUCCESS){
-      fprintf(stderr, "Mandos plugin mandos-client: "
-	      "Syntax error at: %s\n", err);
-      fprintf(stderr, "Mandos plugin mandos-client: "
-	      "GnuTLS error: %s\n", safer_gnutls_strerror(ret));
+      fprintf(stderr, "Syntax error at: %s\n", err);
+      fprintf(stderr, "GnuTLS error: %s\n",
+	      safer_gnutls_strerror(ret));
       gnutls_deinit(*session);
       return -1;
     }
@@ -605,8 +575,7 @@
     }
   } while(ret == GNUTLS_E_INTERRUPTED or ret == GNUTLS_E_AGAIN);
   if(ret != GNUTLS_E_SUCCESS){
-    fprintf(stderr, "Mandos plugin mandos-client: "
-	    "Error setting GnuTLS credentials: %s\n",
+    fprintf(stderr, "Error setting GnuTLS credentials: %s\n",
 	    safer_gnutls_strerror(ret));
     gnutls_deinit(*session);
     return -1;
@@ -658,8 +627,7 @@
     pf = PF_INET;
     break;
   default:
-    fprintf(stderr, "Mandos plugin mandos-client: "
-	    "Bad address family: %d\n", af);
+    fprintf(stderr, "Bad address family: %d\n", af);
     errno = EINVAL;
     return -1;
   }
@@ -670,8 +638,7 @@
   }
   
   if(debug){
-    fprintf(stderr, "Mandos plugin mandos-client: "
-	    "Setting up a TCP connection to %s, port %" PRIu16
+    fprintf(stderr, "Setting up a TCP connection to %s, port %" PRIu16
 	    "\n", ip, port);
   }
   
@@ -704,8 +671,7 @@
   }
   if(ret == 0){
     int e = errno;
-    fprintf(stderr, "Mandos plugin mandos-client: "
-	    "Bad address: %s\n", ip);
+    fprintf(stderr, "Bad address: %s\n", ip);
     errno = e;
     goto mandos_end;
   }
@@ -716,10 +682,9 @@
     
     if(IN6_IS_ADDR_LINKLOCAL /* Spurious warnings from */
        (&to.in6.sin6_addr)){ /* -Wstrict-aliasing=2 or lower and
-				-Wunreachable-code*/
+			      -Wunreachable-code*/
       if(if_index == AVAHI_IF_UNSPEC){
-	fprintf(stderr, "Mandos plugin mandos-client: "
-		"An IPv6 link-local address is incomplete"
+	fprintf(stderr, "An IPv6 link-local address is incomplete"
 		" without a network interface\n");
 	errno = EINVAL;
 	goto mandos_end;
@@ -744,13 +709,12 @@
       if(if_indextoname((unsigned int)if_index, interface) == NULL){
 	perror_plus("if_indextoname");
       } else {
-	fprintf(stderr, "Mandos plugin mandos-client: "
-		"Connection to: %s%%%s, port %" PRIu16 "\n",
+	fprintf(stderr, "Connection to: %s%%%s, port %" PRIu16 "\n",
 		ip, interface, port);
       }
     } else {
-      fprintf(stderr, "Mandos plugin mandos-client: "
-	      "Connection to: %s, port %" PRIu16 "\n", ip, port);
+      fprintf(stderr, "Connection to: %s, port %" PRIu16 "\n", ip,
+	      port);
     }
     char addrstr[(INET_ADDRSTRLEN > INET6_ADDRSTRLEN) ?
 		 INET_ADDRSTRLEN : INET6_ADDRSTRLEN] = "";
@@ -766,8 +730,7 @@
       perror_plus("inet_ntop");
     } else {
       if(strcmp(addrstr, ip) != 0){
-	fprintf(stderr, "Mandos plugin mandos-client: "
-		"Canonical address form: %s\n", addrstr);
+	fprintf(stderr, "Canonical address form: %s\n", addrstr);
       }
     }
   }
@@ -801,7 +764,7 @@
   while(true){
     size_t out_size = strlen(out);
     ret = (int)TEMP_FAILURE_RETRY(write(tcp_sd, out + written,
-					out_size - written));
+				   out_size - written));
     if(ret == -1){
       int e = errno;
       perror_plus("write");
@@ -827,8 +790,7 @@
   }
   
   if(debug){
-    fprintf(stderr, "Mandos plugin mandos-client: "
-	    "Establishing TLS session with %s\n", ip);
+    fprintf(stderr, "Establishing TLS session with %s\n", ip);
   }
   
   if(quit_now){
@@ -854,8 +816,7 @@
   
   if(ret != GNUTLS_E_SUCCESS){
     if(debug){
-      fprintf(stderr, "Mandos plugin mandos-client: "
-	      "*** GnuTLS Handshake failed ***\n");
+      fprintf(stderr, "*** GnuTLS Handshake failed ***\n");
       gnutls_perror(ret);
     }
     errno = EPROTO;
@@ -865,8 +826,8 @@
   /* Read OpenPGP packet that contains the wanted password */
   
   if(debug){
-    fprintf(stderr, "Mandos plugin mandos-client: "
-	    "Retrieving OpenPGP encrypted password from %s\n", ip);
+    fprintf(stderr, "Retrieving OpenPGP encrypted password from %s\n",
+	    ip);
   }
   
   while(true){
@@ -877,7 +838,7 @@
     }
     
     buffer_capacity = incbuffer(&buffer, buffer_length,
-				buffer_capacity);
+				   buffer_capacity);
     if(buffer_capacity == 0){
       int e = errno;
       perror_plus("incbuffer");
@@ -910,16 +871,14 @@
 	  }
 	} while(ret == GNUTLS_E_AGAIN or ret == GNUTLS_E_INTERRUPTED);
 	if(ret < 0){
-	  fprintf(stderr, "Mandos plugin mandos-client: "
-		  "*** GnuTLS Re-handshake failed ***\n");
+	  fprintf(stderr, "*** GnuTLS Re-handshake failed ***\n");
 	  gnutls_perror(ret);
 	  errno = EPROTO;
 	  goto mandos_end;
 	}
 	break;
       default:
-	fprintf(stderr, "Mandos plugin mandos-client: "
-		"Unknown error while reading data from"
+	fprintf(stderr, "Unknown error while reading data from"
 		" encrypted session with Mandos server\n");
 	gnutls_bye(session, GNUTLS_SHUT_RDWR);
 	errno = EIO;
@@ -931,8 +890,7 @@
   }
   
   if(debug){
-    fprintf(stderr, "Mandos plugin mandos-client: "
-	    "Closing TLS session\n");
+    fprintf(stderr, "Closing TLS session\n");
   }
   
   if(quit_now){
@@ -950,7 +908,8 @@
   
   if(buffer_length > 0){
     ssize_t decrypted_buffer_size;
-    decrypted_buffer_size = pgp_packet_decrypt(buffer, buffer_length,
+    decrypted_buffer_size = pgp_packet_decrypt(buffer,
+					       buffer_length,
 					       &decrypted_buffer);
     if(decrypted_buffer_size >= 0){
       
@@ -967,8 +926,7 @@
 	if(ret == 0 and ferror(stdout)){
 	  int e = errno;
 	  if(debug){
-	    fprintf(stderr, "Mandos plugin mandos-client: "
-		    "Error writing encrypted data: %s\n",
+	    fprintf(stderr, "Error writing encrypted data: %s\n",
 		    strerror(errno));
 	  }
 	  errno = e;
@@ -1032,8 +990,7 @@
   switch(event){
   default:
   case AVAHI_RESOLVER_FAILURE:
-    fprintf(stderr, "Mandos plugin mandos-client: "
-	    "(Avahi Resolver) Failed to resolve service '%s'"
+    fprintf(stderr, "(Avahi Resolver) Failed to resolve service '%s'"
 	    " of type '%s' in domain '%s': %s\n", name, type, domain,
 	    avahi_strerror(avahi_server_errno(mc.server)));
     break;
@@ -1043,8 +1000,7 @@
       char ip[AVAHI_ADDRESS_STR_MAX];
       avahi_address_snprint(ip, sizeof(ip), address);
       if(debug){
-	fprintf(stderr, "Mandos plugin mandos-client: "
-		"Mandos server \"%s\" found on %s (%s, %"
+	fprintf(stderr, "Mandos server \"%s\" found on %s (%s, %"
 		PRIdMAX ") on port %" PRIu16 "\n", name, host_name,
 		ip, (intmax_t)interface, port);
       }
@@ -1084,8 +1040,7 @@
   default:
   case AVAHI_BROWSER_FAILURE:
     
-    fprintf(stderr, "Mandos plugin mandos-client: "
-	    "(Avahi browser) %s\n",
+    fprintf(stderr, "(Avahi browser) %s\n",
 	    avahi_strerror(avahi_server_errno(mc.server)));
     avahi_simple_poll_quit(mc.simple_poll);
     return;
@@ -1099,8 +1054,7 @@
     if(avahi_s_service_resolver_new(mc.server, interface, protocol,
 				    name, type, domain, protocol, 0,
 				    resolve_callback, NULL) == NULL)
-      fprintf(stderr, "Mandos plugin mandos-client: "
-	      "Avahi: Failed to resolve service '%s': %s\n",
+      fprintf(stderr, "Avahi: Failed to resolve service '%s': %s\n",
 	      name, avahi_strerror(avahi_server_errno(mc.server)));
     break;
     
@@ -1110,8 +1064,7 @@
   case AVAHI_BROWSER_ALL_FOR_NOW:
   case AVAHI_BROWSER_CACHE_EXHAUSTED:
     if(debug){
-      fprintf(stderr, "Mandos plugin mandos-client: "
-	      "No Mandos server found, still searching...\n");
+      fprintf(stderr, "No Mandos server found, still searching...\n");
     }
     break;
   }
@@ -1132,136 +1085,107 @@
   errno = old_errno;
 }
 
-bool get_flags(const char *ifname, struct ifreq *ifr){
-  int ret;
-  
-  int s = socket(PF_INET6, SOCK_DGRAM, IPPROTO_IP);
-  if(s < 0){
-    perror_plus("socket");
-    return false;
-  }
-  strcpy(ifr->ifr_name, ifname);
-  ret = ioctl(s, SIOCGIFFLAGS, ifr);
-  if(ret == -1){
+/* 
+ * This function determines if a directory entry in /sys/class/net
+ * corresponds to an acceptable network device.
+ * (This function is passed to scandir(3) as a filter function.)
+ */
+int good_interface(const struct dirent *if_entry){
+  ssize_t ssret;
+  char *flagname = NULL;
+  if(if_entry->d_name[0] == '.'){
+    return 0;
+  }
+  int ret = asprintf(&flagname, "%s/%s/flags", sys_class_net,
+		     if_entry->d_name);
+  if(ret < 0){
+    perror_plus("asprintf");
+    return 0;
+  }
+  int flags_fd = (int)TEMP_FAILURE_RETRY(open(flagname, O_RDONLY));
+  if(flags_fd == -1){
+    perror_plus("open");
+    free(flagname);
+    return 0;
+  }
+  free(flagname);
+  typedef short ifreq_flags;	/* ifreq.ifr_flags in netdevice(7) */
+  /* read line from flags_fd */
+  ssize_t to_read = 2+(sizeof(ifreq_flags)*2)+1; /* "0x1003\n" */
+  char *flagstring = malloc((size_t)to_read+1); /* +1 for final \0 */
+  flagstring[(size_t)to_read] = '\0';
+  if(flagstring == NULL){
+    perror_plus("malloc");
+    close(flags_fd);
+    return 0;
+  }
+  while(to_read > 0){
+    ssret = (ssize_t)TEMP_FAILURE_RETRY(read(flags_fd, flagstring,
+					     (size_t)to_read));
+    if(ssret == -1){
+      perror_plus("read");
+      free(flagstring);
+      close(flags_fd);
+      return 0;
+    }
+    to_read -= ssret;
+    if(ssret == 0){
+      break;
+    }
+  }
+  close(flags_fd);
+  intmax_t tmpmax;
+  char *tmp;
+  errno = 0;
+  tmpmax = strtoimax(flagstring, &tmp, 0);
+  if(errno != 0 or tmp == flagstring or (*tmp != '\0'
+					 and not (isspace(*tmp)))
+     or tmpmax != (ifreq_flags)tmpmax){
     if(debug){
-      perror_plus("ioctl SIOCGIFFLAGS");
+      fprintf(stderr, "Invalid flags \"%s\" for interface \"%s\"\n",
+	      flagstring, if_entry->d_name);
     }
-    return false;
+    free(flagstring);
+    return 0;
   }
-  return true;
-}
-
-bool good_flags(const char *ifname, const struct ifreq *ifr){
-  
+  free(flagstring);
+  ifreq_flags flags = (ifreq_flags)tmpmax;
   /* Reject the loopback device */
-  if(ifr->ifr_flags & IFF_LOOPBACK){
+  if(flags & IFF_LOOPBACK){
     if(debug){
-      fprintf(stderr, "Mandos plugin mandos-client: "
-	      "Rejecting loopback interface \"%s\"\n", ifname);
+      fprintf(stderr, "Rejecting loopback interface \"%s\"\n",
+	      if_entry->d_name);
     }
-    return false;
+    return 0;
   }
   /* Accept point-to-point devices only if connect_to is specified */
-  if(connect_to != NULL and (ifr->ifr_flags & IFF_POINTOPOINT)){
+  if(connect_to != NULL and (flags & IFF_POINTOPOINT)){
     if(debug){
-      fprintf(stderr, "Mandos plugin mandos-client: "
-	      "Accepting point-to-point interface \"%s\"\n", ifname);
+      fprintf(stderr, "Accepting point-to-point interface \"%s\"\n",
+	      if_entry->d_name);
     }
-    return true;
+    return 1;
   }
   /* Otherwise, reject non-broadcast-capable devices */
-  if(not (ifr->ifr_flags & IFF_BROADCAST)){
+  if(not (flags & IFF_BROADCAST)){
     if(debug){
-      fprintf(stderr, "Mandos plugin mandos-client: "
-	      "Rejecting non-broadcast interface \"%s\"\n", ifname);
+      fprintf(stderr, "Rejecting non-broadcast interface \"%s\"\n",
+	      if_entry->d_name);
     }
-    return false;
+    return 0;
   }
   /* Reject non-ARP interfaces (including dummy interfaces) */
-  if(ifr->ifr_flags & IFF_NOARP){
+  if(flags & IFF_NOARP){
     if(debug){
-      fprintf(stderr, "Mandos plugin mandos-client: "
-	      "Rejecting non-ARP interface \"%s\"\n", ifname);
+      fprintf(stderr, "Rejecting non-ARP interface \"%s\"\n",
+	      if_entry->d_name);
     }
-    return false;
+    return 0;
   }
-  
   /* Accept this device */
   if(debug){
-    fprintf(stderr, "Mandos plugin mandos-client: "
-	    "Interface \"%s\" is good\n", ifname);
-  }
-  return true;
-}
-
-/* 
- * This function determines if a directory entry in /sys/class/net
- * corresponds to an acceptable network device.
- * (This function is passed to scandir(3) as a filter function.)
- */
-int good_interface(const struct dirent *if_entry){
-  if(if_entry->d_name[0] == '.'){
-    return 0;
-  }
-  
-  struct ifreq ifr;
-  if(not get_flags(if_entry->d_name, &ifr)){
-    if(debug){
-      fprintf(stderr, "Mandos plugin mandos-client: "
-	      "Failed to get flags for interface \"%s\"\n",
-	      if_entry->d_name);
-    }
-    return 0;
-  }
-  
-  if(not good_flags(if_entry->d_name, &ifr)){
-    return 0;
-  }
-  return 1;
-}
-
-/* 
- * This function determines if a directory entry in /sys/class/net
- * corresponds to an acceptable network device which is up.
- * (This function is passed to scandir(3) as a filter function.)
- */
-int up_interface(const struct dirent *if_entry){
-  if(if_entry->d_name[0] == '.'){
-    return 0;
-  }
-  
-  struct ifreq ifr;
-  if(not get_flags(if_entry->d_name, &ifr)){
-    if(debug){
-      fprintf(stderr, "Mandos plugin mandos-client: "
-	      "Failed to get flags for interface \"%s\"\n",
-	      if_entry->d_name);
-    }
-    return 0;
-  }
-  
-  /* Reject down interfaces */
-  if(not (ifr.ifr_flags & IFF_UP)){
-    if(debug){
-      fprintf(stderr, "Mandos plugin mandos-client: "
-	      "Rejecting down interface \"%s\"\n",
-	      if_entry->d_name);
-    }
-    return 0;
-  }
-  
-  /* Reject non-running interfaces */
-  if(not (ifr.ifr_flags & IFF_RUNNING)){
-    if(debug){
-      fprintf(stderr, "Mandos plugin mandos-client: "
-	      "Rejecting non-running interface \"%s\"\n",
-	      if_entry->d_name);
-    }
-    return 0;
-  }
-  
-  if(not good_flags(if_entry->d_name, &ifr)){
-    return 0;
+    fprintf(stderr, "Interface \"%s\" is acceptable\n",
+	    if_entry->d_name);
   }
   return 1;
 }
@@ -1277,66 +1201,6 @@
   return 1;
 }
 
-/* Is this directory entry a runnable program? */
-int runnable_hook(const struct dirent *direntry){
-  int ret;
-  size_t sret;
-  struct stat st;
-  
-  if((direntry->d_name)[0] == '\0'){
-    /* Empty name? */
-    return 0;
-  }
-  
-  sret = strspn(direntry->d_name, "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
-		"abcdefghijklmnopqrstuvwxyz"
-		"0123456789"
-		"_-");
-  if((direntry->d_name)[sret] != '\0'){
-    /* Contains non-allowed characters */
-    if(debug){
-      fprintf(stderr, "Mandos plugin mandos-client: "
-	      "Ignoring hook \"%s\" with bad name\n",
-	      direntry->d_name);
-    }
-    return 0;
-  }
-  
-  char *fullname = NULL;
-  ret = asprintf(&fullname, "%s/%s", hookdir, direntry->d_name);
-  if(ret < 0){
-    perror_plus("asprintf");
-    return 0;
-  }
-  
-  ret = stat(fullname, &st);
-  if(ret == -1){
-    if(debug){
-      perror_plus("Could not stat hook");
-    }
-    return 0;
-  }
-  if(not (S_ISREG(st.st_mode))){
-    /* Not a regular file */
-    if(debug){
-      fprintf(stderr, "Mandos plugin mandos-client: "
-	      "Ignoring hook \"%s\" - not a file\n",
-	      direntry->d_name);
-    }
-    return 0;
-  }
-  if(not (st.st_mode & (S_IXUSR | S_IXGRP | S_IXOTH))){
-    /* Not executable */
-    if(debug){
-      fprintf(stderr, "Mandos plugin mandos-client: "
-	      "Ignoring hook \"%s\" - not executable\n",
-	      direntry->d_name);
-    }
-    return 0;
-  }
-  return 1;
-}
-
 int avahi_loop_with_timeout(AvahiSimplePoll *s, int retry_interval){
   int ret;
   struct timespec now;
@@ -1346,14 +1210,13 @@
   while(true){
     if(mc.current_server == NULL){
       if (debug){
-	fprintf(stderr, "Mandos plugin mandos-client: "
+	fprintf(stderr,
 		"Wait until first server is found. No timeout!\n");
       }
       ret = avahi_simple_poll_iterate(s, -1);
     } else {
       if (debug){
-	fprintf(stderr, "Mandos plugin mandos-client: "
-		"Check current_server if we should run it,"
+	fprintf(stderr, "Check current_server if we should run it,"
 		" or wait\n");
       }
       /* the current time */
@@ -1376,8 +1239,7 @@
 		    - ((intmax_t)waited_time.tv_nsec / 1000000));
       
       if (debug){
-	fprintf(stderr, "Mandos plugin mandos-client: "
-		"Blocking for %" PRIdMAX " ms\n", block_time);
+	fprintf(stderr, "Blocking for %" PRIdMAX " ms\n", block_time);
       }
       
       if(block_time <= 0){
@@ -1403,7 +1265,7 @@
       ret = avahi_simple_poll_iterate(s, (int)block_time);
     }
     if(ret != 0){
-      if (ret > 0 or errno != EINTR){
+      if (ret > 0 or errno != EINTR) {
 	return (ret != 1) ? ret : 0;
       }
     }
@@ -1497,10 +1359,6 @@
 	.arg = "SECONDS",
 	.doc = "Retry interval used when denied by the mandos server",
 	.group = 2 },
-      { .name = "network-hook-dir", .key = 133,
-	.arg = "DIR",
-	.doc = "Directory where network hooks are located",
-	.group = 2 },
       /*
        * These reproduce what we would get without ARGP_NO_HELP
        */
@@ -1559,9 +1417,6 @@
 	  argp_error(state, "Bad retry interval");
 	}
 	break;
-      case 133:			/* --network-hook-dir */
-	hookdir = arg;
-	break;
 	/*
 	 * These reproduce what we would get without ARGP_NO_HELP
 	 */
@@ -1573,7 +1428,6 @@
 	argp_state_help(state, state->out_stream,
 			ARGP_HELP_USAGE | ARGP_HELP_EXIT_ERR);
       case 'V':			/* --version */
-	fprintf(state->out_stream, "Mandos plugin mandos-client: ");
 	fprintf(state->out_stream, "%s\n", argp_program_version);
 	exit(argp_err_exit_status);
 	break;
@@ -1664,121 +1518,19 @@
     }
   }
   
-  /* Find network hooks and run them */
-  {
-    struct dirent **direntries;
-    struct dirent *direntry;
-    int numhooks = scandir(hookdir, &direntries, runnable_hook,
-			   alphasort);
-    if(numhooks == -1){
-      perror_plus("scandir");
-    } else {
-      int devnull = open("/dev/null", O_RDONLY);
-      for(int i = 0; i < numhooks; i++){
-	direntry = direntries[0];
-	char *fullname = NULL;
-	ret = asprintf(&fullname, "%s/%s", hookdir, direntry->d_name);
-	if(ret < 0){
-	  perror_plus("asprintf");
-	  continue;
-	}
-	pid_t hook_pid = fork();
-	if(hook_pid == 0){
-	  /* Child */
-	  dup2(devnull, STDIN_FILENO);
-	  close(devnull);
-	  dup2(STDERR_FILENO, STDOUT_FILENO);
-	  ret = setenv("DEVICE", interface, 1);
-	  if(ret == -1){
-	    perror_plus("setenv");
-	    exit(1);
-	  }
-	  ret = setenv("VERBOSE", debug ? "1" : "0", 1);
-	  if(ret == -1){
-	    perror_plus("setenv");
-	    exit(1);
-	  }
-	  ret = setenv("MODE", "start", 1);
-	  if(ret == -1){
-	    perror_plus("setenv");
-	    exit(1);
-	  }
-	  char *delaystring;
-	  ret = asprintf(&delaystring, "%f", delay);
-	  if(ret == -1){
-	    perror_plus("asprintf");
-	    exit(1);
-	  }
-	  ret = setenv("DELAY", delaystring, 1);
-	  if(ret == -1){
-	    free(delaystring);
-	    perror_plus("setenv");
-	    exit(1);
-	  }
-	  free(delaystring);
-	  ret = execl(fullname, direntry->d_name, "start", NULL);
-	  perror_plus("execl");
-	} else {
-	  int status;
-	  if(TEMP_FAILURE_RETRY(waitpid(hook_pid, &status, 0)) == -1){
-	    perror_plus("waitpid");
-	    free(fullname);
-	    continue;
-	  }
-	  if(WIFEXITED(status)){
-	    if(WEXITSTATUS(status) != 0){
-	      fprintf(stderr, "Mandos plugin mandos-client: "
-		      "Warning: network hook \"%s\" exited"
-		      " with status %d\n", direntry->d_name,
-		      WEXITSTATUS(status));
-	      free(fullname);
-	      continue;
-	    }
-	  } else if(WIFSIGNALED(status)){
-	    fprintf(stderr, "Mandos plugin mandos-client: "
-		    "Warning: network hook \"%s\" died by"
-		    " signal %d\n", direntry->d_name,
-		    WTERMSIG(status));
-	    free(fullname);
-	    continue;
-	  } else {
-	    fprintf(stderr, "Mandos plugin mandos-client: "
-		    "Warning: network hook \"%s\" crashed\n",
-		    direntry->d_name);
-	    free(fullname);
-	    continue;
-	  }
-	}
-	free(fullname);
-	if(quit_now){
-	  goto end;
-	}
-      }
-      close(devnull);
-    }
-  }
-  
   if(not debug){
     avahi_set_log_function(empty_log);
   }
-  
+
   if(interface[0] == '\0'){
     struct dirent **direntries;
-    /* First look for interfaces that are up */
-    ret = scandir(sys_class_net, &direntries, up_interface,
+    ret = scandir(sys_class_net, &direntries, good_interface,
 		  alphasort);
-    if(ret == 0){
-      /* No up interfaces, look for any good interfaces */
-      free(direntries);
-      ret = scandir(sys_class_net, &direntries, good_interface,
-		    alphasort);
-    }
     if(ret >= 1){
-      /* Pick the first interface returned */
+      /* Pick the first good interface */
       interface = strdup(direntries[0]->d_name);
       if(debug){
-	fprintf(stderr, "Mandos plugin mandos-client: "
-		"Using interface \"%s\"\n", interface);
+	fprintf(stderr, "Using interface \"%s\"\n", interface);
       }
       if(interface == NULL){
 	perror_plus("malloc");
@@ -1789,8 +1541,7 @@
       free(direntries);
     } else {
       free(direntries);
-      fprintf(stderr, "Mandos plugin mandos-client: "
-	      "Could not find a network interface\n");
+      fprintf(stderr, "Could not find a network interface\n");
       exitcode = EXIT_FAILURE;
       goto end;
     }
@@ -1802,8 +1553,7 @@
   srand((unsigned int) time(NULL));
   mc.simple_poll = avahi_simple_poll_new();
   if(mc.simple_poll == NULL){
-    fprintf(stderr, "Mandos plugin mandos-client: "
-	    "Avahi: Failed to create simple poll object.\n");
+    fprintf(stderr, "Avahi: Failed to create simple poll object.\n");
     exitcode = EX_UNAVAILABLE;
     goto end;
   }
@@ -1875,8 +1625,7 @@
   if(strcmp(interface, "none") != 0){
     if_index = (AvahiIfIndex) if_nametoindex(interface);
     if(if_index == 0){
-      fprintf(stderr, "Mandos plugin mandos-client: "
-	      "No such interface: \"%s\"\n", interface);
+      fprintf(stderr, "No such interface: \"%s\"\n", interface);
       exitcode = EX_UNAVAILABLE;
       goto end;
     }
@@ -2023,8 +1772,7 @@
   
   ret = init_gnutls_global(pubkey, seckey);
   if(ret == -1){
-    fprintf(stderr, "Mandos plugin mandos-client: "
-	    "init_gnutls_global failed\n");
+    fprintf(stderr, "init_gnutls_global failed\n");
     exitcode = EX_UNAVAILABLE;
     goto end;
   } else {
@@ -2046,8 +1794,7 @@
   }
   
   if(not init_gpgme(pubkey, seckey, tempdir)){
-    fprintf(stderr, "Mandos plugin mandos-client: "
-	    "init_gpgme failed\n");
+    fprintf(stderr, "init_gpgme failed\n");
     exitcode = EX_UNAVAILABLE;
     goto end;
   } else {
@@ -2063,8 +1810,7 @@
     /* (Mainly meant for debugging) */
     char *address = strrchr(connect_to, ':');
     if(address == NULL){
-      fprintf(stderr, "Mandos plugin mandos-client: "
-	      "No colon in address\n");
+      fprintf(stderr, "No colon in address\n");
       exitcode = EX_USAGE;
       goto end;
     }
@@ -2078,8 +1824,7 @@
     tmpmax = strtoimax(address+1, &tmp, 10);
     if(errno != 0 or tmp == address+1 or *tmp != '\0'
        or tmpmax != (uint16_t)tmpmax){
-      fprintf(stderr, "Mandos plugin mandos-client: "
-	      "Bad port number\n");
+      fprintf(stderr, "Bad port number\n");
       exitcode = EX_USAGE;
       goto end;
     }
@@ -2115,8 +1860,8 @@
 	break;
       }
       if(debug){
-	fprintf(stderr, "Mandos plugin mandos-client: "
-		"Retrying in %d seconds\n", (int)retry_interval);
+	fprintf(stderr, "Retrying in %d seconds\n",
+		(int)retry_interval);
       }
       sleep((int)retry_interval);
     }
@@ -2124,7 +1869,7 @@
     if (not quit_now){
       exitcode = EXIT_SUCCESS;
     }
-    
+
     goto end;
   }
   
@@ -2152,8 +1897,7 @@
   
   /* Check if creating the Avahi server object succeeded */
   if(mc.server == NULL){
-    fprintf(stderr, "Mandos plugin mandos-client: "
-	    "Failed to create Avahi server: %s\n",
+    fprintf(stderr, "Failed to create Avahi server: %s\n",
 	    avahi_strerror(error));
     exitcode = EX_UNAVAILABLE;
     goto end;
@@ -2168,8 +1912,7 @@
 				   AVAHI_PROTO_UNSPEC, "_mandos._tcp",
 				   NULL, 0, browse_callback, NULL);
   if(sb == NULL){
-    fprintf(stderr, "Mandos plugin mandos-client: "
-	    "Failed to create service browser: %s\n",
+    fprintf(stderr, "Failed to create service browser: %s\n",
 	    avahi_strerror(avahi_server_errno(mc.server)));
     exitcode = EX_UNAVAILABLE;
     goto end;
@@ -2182,23 +1925,20 @@
   /* Run the main loop */
   
   if(debug){
-    fprintf(stderr, "Mandos plugin mandos-client: "
-	    "Starting Avahi loop search\n");
+    fprintf(stderr, "Starting Avahi loop search\n");
   }
 
   ret = avahi_loop_with_timeout(mc.simple_poll,
 				(int)(retry_interval * 1000));
   if(debug){
-    fprintf(stderr, "Mandos plugin mandos-client: "
-	    "avahi_loop_with_timeout exited %s\n",
+    fprintf(stderr, "avahi_loop_with_timeout exited %s\n",
 	    (ret == 0) ? "successfully" : "with error");
   }
   
  end:
   
   if(debug){
-    fprintf(stderr, "Mandos plugin mandos-client: "
-	    "%s exiting\n", argv[0]);
+    fprintf(stderr, "%s exiting\n", argv[0]);
   }
   
   /* Cleanup things */
@@ -2232,8 +1972,6 @@
     }
   }
   
-  /* XXX run network hooks "stop" here  */
-  
   /* Take down the network interface */
   if(take_down_interface){
     /* Re-raise priviliges */
@@ -2246,7 +1984,7 @@
       ret = ioctl(sd, SIOCGIFFLAGS, &network);
       if(ret == -1){
 	perror_plus("ioctl SIOCGIFFLAGS");
-      } else if(network.ifr_flags & IFF_UP){
+      } else if(network.ifr_flags & IFF_UP) {
 	network.ifr_flags &= ~(short)IFF_UP; /* clear flag */
 	ret = ioctl(sd, SIOCSIFFLAGS, &network);
 	if(ret == -1){
@@ -2284,8 +2022,8 @@
 	}
 	ret = remove(fullname);
 	if(ret == -1){
-	  fprintf(stderr, "Mandos plugin mandos-client: "
-		  "remove(\"%s\"): %s\n", fullname, strerror(errno));
+	  fprintf(stderr, "remove(\"%s\"): %s\n", fullname,
+		  strerror(errno));
 	}
 	free(fullname);
       }

=== modified file 'plugins.d/mandos-client.xml'
--- plugins.d/mandos-client.xml	2011-11-12 18:04:35 +0000
+++ plugins.d/mandos-client.xml	2011-10-05 16:00:56 +0000
@@ -102,10 +102,6 @@
       </arg>
       <sbr/>
       <arg>
-	<option>--network-hook-dir<replaceable>DIR</replaceable></option>
-      </arg>
-      <sbr/>
-      <arg>
 	<option>--debug</option>
       </arg>
     </cmdsynopsis>
@@ -315,18 +311,6 @@
 	  </para>
 	</listitem>
       </varlistentry>
-
-      <varlistentry>
-	<term><option>--network-hook-dir=<replaceable
-	>DIR</replaceable></option></term>
-	<listitem>
-	  <para>
-	    Network hook directory.  The default directory is
-	    <quote><directory class="directory"
-	    >/lib/mandos/network-hooks.d</directory></quote>.
-	  </para>
-	</listitem>
-      </varlistentry>
       
       <varlistentry>
 	<term><option>--debug</option></term>

